Loading...
Searching...
No Matches
casacore::MCEpoch Class Reference
measures package (libcasa_measures) » Measures_module » Measures_module_internal_classes

More...

`#include <MCEpoch.h>`

## Public Member Functions

| MCEpoch ()
| Default constructor.
| ~MCEpoch ()
Public Member Functions inherited from casacore::MCBase
virtual | ~MCBase ()

## Static Public Member Functions

static String | showState ()
| Show the state of the conversion engine (mainly for debugging purposes).

## Private Types

enum | Routes { LAST_GAST , GAST_LAST , LMST_GMST1 , GMST1_LMST , GMST1_UT1 , UT1_GMST1 , GAST_UT1 , UT1_GAST , UT1_UTC , UTC_UT1 , UT1_UT2 , UT2_UT1 , UTC_TAI , TAI_UTC , TAI_TDT , TDT_TAI , TDT_TDB , TDB_TDT , TDT_TCG , TCG_TDT , TDB_TCB , TCB_TDB , N_Routes , RAZING }
| The list of actual routines provided. More...

## Private Member Functions

| MCEpoch (const MCEpoch &other)
| Copy constructor (not implemented).
MCEpoch & | operator= (const MCEpoch &other)
| Assignment (not implemented).
virtual void | getConvert (MConvertBase &mc, const MRBase &inref, const MRBase &outref)
| Create conversion function pointer.
virtual void | initConvert (uInt which, MConvertBase &mc)
| Create help structures for Measure conversion routines.
virtual void | clearConvert ()
| Delete the pointers used in the MeasConvert help structure cache.
virtual void | doConvert (MeasValue &in, MRBase &inref, MRBase &outref, const MConvertBase &mc)
| Routine to convert time from one reference frame to another.
void | doConvert (MVEpoch &in, MRBase &inref, MRBase &outref, const MConvertBase &mc)
| Conversion routine to cater for inheritance question.

## Static Private Member Functions

static void | doFillState ()
| Fill the global state.

## Private Attributes

Nutation * | NUTATFROM
Nutation * | NUTATTO

## Static Private Attributes

static uInt | ToRef_p [N_Routes][3]
| Transition list.
static uInt | FromTo_p [MEpoch::N_Types][MEpoch::N_Types]
| Transition matrix.
static std::once_flag | theirInitOnceFlag
| Object to ensure safe multi-threaded lazy single initialization.

## Friends

class | MeasConvert< MEpoch >

## Additional Inherited Members

Public Types inherited from casacore::MCBase
enum | Routes { N_Routes }
| Each derived class should have a list of routines to be called: More...
Static Protected Member Functions inherited from casacore::MCBase
static void | makeState (uInt *state, const uInt ntyp, const uInt nrout, const uInt list[][3])
| The following routines create a state transition matrix from a list of all defined transitions.
static String | showState (uInt *state, const uInt ntyp, const uInt nrout, const uInt list[][3])
| Return a fromatted String with matrix information (based on < 100 types).

## Detailed Description

MEpoch conversion routines

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25
Test programs:
  tMeasure

### Prerequisite

- Measure class
- MCBase base class
- overall conversion class

### Etymology

Measure, Convert and Epoch

### Synopsis

Contains state machinery and caching for actual conversions

### Example

Convert (with all steps explicit) a UTC to an IAT time.

#include <casacore/measures/Measures.h>
#include <casacore/measures/Measures/MEpoch.h>
#include <casacore/measures/Measures/MCEpoch.h>
cout << "TAI for UTC = MJD(50237.29): " <<
MEpoch::Convert(MEpoch(MVEpoch(Quantity(50237.29, "d")),
MEpoch::Ref(MEpoch::UTC)),
MEpoch::Ref(MEpoch::TAI))() <<
endl;
casacore::MEpoch
Definition MEpoch.h:101
casacore::MEpoch::TAI
@ TAI
Definition MEpoch.h:126
casacore::MEpoch::UTC
@ UTC
Definition MEpoch.h:125
casacore::MEpoch::Ref
MeasRef< MEpoch > Ref
Measure reference (i.e.
Definition MEpoch.h:153
casacore::MEpoch::Convert
MeasConvert< MEpoch > Convert
Measure Convert (i.e.
Definition MEpoch.h:155
casacore::MVEpoch
Definition MVEpoch.h:87
casacore::Quantity
Quantum< Double > Quantity
Definition Quantum.h:39

### Motivation

### To Do

- Nothing I know

Definition at line 88 of file MCEpoch.h.

## Member Enumeration Documentation

## Routes

enum casacore::MCEpoch::Routes

private

The list of actual routines provided.

Warning: Each AA_BB in the list points to routine that can be used in the FromTo list in the getConvert routine; In addition the type to which each is converted should be in the ToRef array, again in the proper order;

Enumerator
LAST_GAST |
GAST_LAST |
LMST_GMST1 |
GMST1_LMST |
GMST1_UT1 |
UT1_GMST1 |
GAST_UT1 |
UT1_GAST |
UT1_UTC |
UTC_UT1 |
UT1_UT2 |
UT2_UT1 |
UTC_TAI |
TAI_UTC |
TAI_TDT |
TDT_TAI |
TDT_TDB |
TDB_TDT |
TDT_TCG |
TCG_TDT |
TDB_TCB |
TCB_TDB |
N_Routes |
RAZING |

Definition at line 113 of file MCEpoch.h.

## Constructor & Destructor Documentation

## MCEpoch() [1/2]

casacore::MCEpoch::MCEpoch | ( |  | ) |

Default constructor.

Referenced by MCEpoch(), MeasConvert< MEpoch >, and operator=().

## ~MCEpoch()

casacore::MCEpoch::~MCEpoch | ( |  | ) |

## MCEpoch() [2/2]

casacore::MCEpoch::MCEpoch | ( | const MCEpoch & | other | ) |

private

Copy constructor (not implemented).

References MCEpoch().

## Member Function Documentation

## clearConvert()

virtual void casacore::MCEpoch::clearConvert | ( |  | ) |

private virtual

Delete the pointers used in the MeasConvert help structure cache.

Implements casacore::MCBase.

## doConvert() [1/2]

virtual void casacore::MCEpoch::doConvert | ( | MeasValue & | in,
|  | MRBase & | inref,
|  | MRBase & | outref,
|  | const MConvertBase & | mc )

private virtual

Routine to convert time from one reference frame to another.

Implements casacore::MCBase.

## doConvert() [2/2]

void casacore::MCEpoch::doConvert | ( | MVEpoch & | in,
|  | MRBase & | inref,
|  | MRBase & | outref,
|  | const MConvertBase & | mc )

private

Conversion routine to cater for inheritance question.

## doFillState()

void casacore::MCEpoch::doFillState | ( |  | ) |

static private

Fill the global state.

Called using theirInitOnce.

## getConvert()

virtual void casacore::MCEpoch::getConvert | ( | MConvertBase & | mc,
|  | const MRBase & | inref,
|  | const MRBase & | outref )

private virtual

Create conversion function pointer.

Implements casacore::MCBase.

## initConvert()

virtual void casacore::MCEpoch::initConvert | ( | uInt | which,
|  | MConvertBase & | mc )

private virtual

Create help structures for Measure conversion routines.

Implements casacore::MCBase.

## operator=()

MCEpoch & casacore::MCEpoch::operator= | ( | const MCEpoch & | other | ) |

private

Assignment (not implemented).

References MCEpoch().

## showState()

String casacore::MCEpoch::showState | ( |  | ) |

static

Show the state of the conversion engine (mainly for debugging purposes).

## Friends And Related Symbol Documentation

## MeasConvert< MEpoch >

friend class MeasConvert< MEpoch >

friend

Definition at line 1 of file MCEpoch.h.

References MCEpoch().

## Member Data Documentation

## FromTo_p

uInt casacore::MCEpoch::FromTo_p[MEpoch::N_Types][MEpoch::N_Types]

static private

Transition matrix.

Definition at line 156 of file MCEpoch.h.

## NUTATFROM

Nutation* casacore::MCEpoch::NUTATFROM

private

Definition at line 149 of file MCEpoch.h.

## NUTATTO

Nutation* casacore::MCEpoch::NUTATTO

private

Definition at line 150 of file MCEpoch.h.

## theirInitOnceFlag

std::once_flag casacore::MCEpoch::theirInitOnceFlag

static private

Object to ensure safe multi-threaded lazy single initialization.

Definition at line 158 of file MCEpoch.h.

## ToRef_p

uInt casacore::MCEpoch::ToRef_p[N_Routes][3]

static private

Transition list.

Definition at line 154 of file MCEpoch.h.

The documentation for this class was generated from the following file:

- measures/Measures/MCEpoch.h